package com.company.sample.entity;

import com.company.sample.app.AppCRSs;
import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;
import io.jmix.core.metamodel.annotation.JmixProperty;
import jakarta.persistence.*;
import org.locationtech.jts.geom.Point;

import java.util.UUID;

@JmixEntity
@Table(name = "POINT_BNG")
@Entity
public class PointBng {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @InstanceName
    @Column(name = "NAME")
    private String name;

    @Column(name = "POINT")
    private Point point;

    @JmixProperty
    @Transient
    private Point pointWgs;

    public Point getPointWgs() {
        return pointWgs;
    }

    public void setPoint(Point point) {
        this.point = point;
        updateWGS();
    }

    public Point getPoint() {
        return point;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }

    @PostLoad
    public void postLoad() {
        updateWGS();
    }

    private void updateWGS() {
        this.pointWgs = AppCRSs.convert(point, AppCRSs.EPSG_27700, AppCRSs.EPSG_4326);
    }
}